using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace JelliesAPlenty.Sprite
{
    class SpriteManagement
    {
        
        public SpriteManagement()
        {
           
        }//End New

        //The textures used by the Sprites
        Dictionary<string, Texture2D> mTextures = new Dictionary<string, Texture2D>();
        public Dictionary<string, Texture2D> Textures
        {
            get
            {
                return mTextures;
            }
            set
            {
                mTextures = value;
            }
        }//End Textures Property

        //private SpriteBatch mSpriteBatch;
        //public SpriteBatch MySpriteBatch
        //{
        //    get
        //    {
        //        return mSpriteBatch;
        //    }
        //    set
        //    {
        //        mSpriteBatch = value;
        //    }
        //}

        //Sprites
        Dictionary<string, Sprite> mSprites = new Dictionary<string, Sprite>();
        public Dictionary<string, Sprite> Sprites
        {
            get
            {
                return mSprites;
            }
            set
            {
                mSprites = value;
            }
        }


        public void Draw(SpriteBatch theSpriteBatch)
        {
           
            foreach (KeyValuePair<string, Sprite> aSprite in Sprites)
            {
                if (aSprite.Value.Visible == true)
                {
                    if (aSprite.Value.TextureWidth == 0 && aSprite.Value.TextureHeight == 0)
                    {
                        theSpriteBatch.Draw(Textures[aSprite.Value.TextureKey], aSprite.Value.Destination, Color.White);
                    }
                    else
                    {
                        theSpriteBatch.Draw(Textures[aSprite.Value.TextureKey], aSprite.Value.Destination, aSprite.Value.Source, Color.White);
                    }
                }
            }
        }//End Draw()

        public void Draw(SpriteBatch theSpriteBatch, string theKey)
        {
            if (Sprites[theKey].Visible == true)
            {
                if (Sprites[theKey].TextureWidth == 0 && Sprites[theKey].TextureHeight == 0)
                {
                    theSpriteBatch.Draw(Textures[Sprites[theKey].TextureKey], Sprites[theKey].Destination, Color.White);
                }
                else
                {
                    theSpriteBatch.Draw(Textures[Sprites[theKey].TextureKey], Sprites[theKey].Destination, Sprites[theKey].Source, Color.White);
                }
            }
        }

        public void Update(float elapsed)
        {

            foreach (KeyValuePair<string, Sprite> aSprite in Sprites)
            {
                if (aSprite.Value.VisibleTime != 0)
                {
                    aSprite.Value.Elapsed -= elapsed;
                }
            }

        }//End Update()

    }
}
